Subject: bug#46495: 28.0.50; [native-comp] Build fails for 32bit --with-wide-int

From: Andrea Corallo <[email-masked]>
Date: Wed, 31 Mar 2021 12:16:14 +0000

Eli Zaretskii <[email-masked]> writes:

>> From: Andrea Corallo <[email-masked]>
>> Cc: [email-masked], [email-masked], [email-masked]
>> Date: Wed, 31 Mar 2021 08:47:37 +0000
>> 
>> > AFAIU, this means the libgccjit log file is only output with
>> > comp-debug 3 and higher?
>> 
>> Correct, the docstring wasn't correct :/ aa159bf696 should update it to
>> reflect the current situation.
>
> Thanks.
>
>> > Also, does comp-debug = 3 indeed cause the
>> > reproducer to be written, or is that controlled independently by
>> > comp-libgccjit-reproducer?
>> 
>> The reproducer is controlled independently by
>> `comp-libgccjit-reproducer', the idea behind this is that we want to be
>> able to produce reproducers independently from the debug settings (we
>> might have a ligccjit bug that is related to one debug option).
>
> Right, so comp-debug = 3 alone doesn't trigger the reproducer, right?

That's correct.

>> My proposal would be like:
>> 
>> 0 none
>> 1 debug symbols
>> 2 debug symbols + pseudo C file
>> 3 debug symbols + pseudo C file + GCC passes + libgccjit log file
>> 
>> I think the backtrace issue you are facing is clearly a gdb unwinder
>> limitation on Windows that should be fixed in gdb.
>
> It's more like a missing feature in GDB on platforms that don't use
> ELF binary format.  I don't hold my breath to have the situation
> improved, since this is so far a rare situation when debugging
> programs: no one expects debugging code without debug symbols to be
> easy.
>
>> OTOH I understand we can't update gdb for all users that might want
>> to help debugging an issue, but I don't like very much the idea to
>> have comp-debug 1 as default on every system.  What about having 1
>> as default only on Windows?  WDYT?
>
> In general, I'd prefer these settings to be the same on all platforms,
> although it isn't a strong feeling in this case.  But I'm curious why
> you are so against doing that by default on other systems.  Can you
> explain?

Nothing special, just that that as on GNU/Linux we can produce
backtraces without debug symbols so seams to me it would be a waste of
space to have them always present just for this reason.

> Anyway, I've compiled the relevant files with comp-debug = 1, and the
> problems with backtraces are now completely gone.  So I think we can
> more or less close this issue (modulo changing the meanings of
> comp-debug and the decision regarding the default value).

Sounds good, if my proposal of the new 4 values is acceptable for you
and we decide on the default one I can proceed with that.

Thanks

  Andrea